api/urls.py
from django.urls import path

from . import views
from graphs import views as graph_views


app_name = 'api'
urlpatterns = [
    path('datasets', views.dataset_list, name='dataset-list'),
    path('dataset/<slug>', views.dataset_detail, name='dataset-detail'),
    path('dataset/<slug>/<tablename>/data', views.dataset_data, name='dataset-table-data'),
    path('especiais/grafo/sociedades', graph_views.GetResourceNetworkView.as_view(), name='resource-graph'),
    path('especiais/grafo/sociedades/caminhos', graph_views.GetPartnershipPathsView.as_view(), name='partnership-paths'),
    path('especiais/grafo/sociedades/subsequentes', graph_views.GetCompanySubsequentPartnershipsGraphView.as_view(), name='subsequent-partnerships'),
    path('especiais/grafo/sociedades/empresas-mae', graph_views.CNPJCompanyGroupsView.as_view(), name='company-groups'),
    path('especiais/grafo/no', graph_views.GetNodeDataView.as_view(), name='node-data'),
]

brasilio/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('admin/', admin.site.urls),
    path('api/', include('api.urls', namespace='api')),
    path('auth/', include('brasilio_auth.urls', namespace='brasilio_auth')),
    path('', include('core.urls', namespace='core')),
]

core/urls.py
from django.urls import path, reverse_lazy
from django.contrib.auth.decorators import login_required

from . import views, views_special

sign_up_url = reverse_lazy('brasilio_auth:sign_up')


app_name = 'core'
urlpatterns = [
    # Institutional pages
    path('', views.index, name='index'),
    path('contato', views.contact, name='contact'),
    path('datasets', views.dataset_list, name='dataset-list'),
    path('home', views.home, name='home'),
    path('dataset/<slug>', views.dataset_detail, name='dataset-detail'),
    path('dataset/<slug>/<tablename>', views.dataset_detail, name='dataset-table-detail'),
    path('datasets/sugira', views.dataset_suggestion, name='dataset-suggestion'),
    path('manifesto', views.manifesto, name='manifesto'),
    path('colabore', views.collaborate, name='collaborate'),
    path('doe', views.donate, name='donate'),

    # Dataset-specific pages (specials)
    path('especiais', views_special.index, name='specials'),
    path('especiais/documento/<document>', login_required(views_special.document_detail, login_url=sign_up_url), name='special-document-detail'),
    path('especiais/caminho', login_required(views_special.trace_path, login_url=sign_up_url), name='special-trace-path'),
    path('especiais/grupos', login_required(views_special.company_groups, login_url=sign_up_url), name='special-company-groups'),
]

core/forms.py
from django import forms
from django.core.exceptions import ObjectDoesNotExist

from core.models import Dataset
from core.util import get_company_by_document


def _resolve_field_by_type(person_type):
    if person_type == 'pessoa-fisica':
        return 'nome_socio'
    elif person_type == 'pessoa-juridica':
        return 'cnpj'


def _get_obj(field, identifier, person_type):
    if person_type == 'pessoa-fisica':
        Socios = Dataset.objects.get(slug='socios-brasil')\
                                .get_table('socios')\
                                .get_model()
        return Socios.objects.filter(**{field: identifier}).first()
    elif person_type == 'pessoa-juridica':
        try:
            return get_company_by_document(identifier)
        except ObjectDoesNotExist:
            return None


def _get_name(obj, person_type):
    if person_type == 'pessoa-fisica':
        return obj.nome_socio
    elif person_type == 'pessoa-juridica':
        return obj.name


class TracePathForm(forms.Form):
    TYPE_CHOICES = [
        ('pessoa-fisica', 'Pessoa Física (nome completo)'),
        ('pessoa-juridica', 'Pessoa Jurídica (CNPJ)')
    ]

    origin_type = forms.ChoiceField(choices=TYPE_CHOICES, required=True)
    origin_identifier = forms.CharField(required=True)

    destination_type = forms.ChoiceField(choices=TYPE_CHOICES, required=True)
    destination_identifier = forms.CharField(required=True)

    def clean(self):
        cleaned_data = super().clean()
        origin_type = cleaned_data.get('origin_type')
        origin_identifier = cleaned_data.get('origin_identifier')
        destination_type = cleaned_data.get('destination_type')
        destination_identifier = cleaned_data.get('destination_identifier')


        origin_field = _resolve_field_by_type(origin_type)
        destination_field = _resolve_field_by_type(destination_type)
        origin = _get_obj(origin_field, origin_identifier, origin_type)
        destination = _get_obj(destination_field, destination_identifier, destination_type)

        if origin is None:
            self.add_error('origin_identifier', 'Name/document not found')
        else:
            cleaned_data['origin_name'] = _get_name(origin, origin_type)
        if destination is None:
            self.add_error('destination_identifier', 'Name/document not found')
        else:
            cleaned_data['destination_name'] = _get_name(destination, destination_type)

        return cleaned_data


class CompanyGroupsForm(forms.Form):
    identifier = forms.CharField(required=True, label='CNPJ')

    def clean(self):
        cleaned_data = super().clean()
        identifier = cleaned_data['identifier']
        for char in './-':
            identifier = identifier.replace(char, '')
        company = _get_obj('', identifier, 'pessoa-juridica')
        if not company:
            self.add_error('identifier', 'Document not found')
        else:
            cleaned_data['company'] = company
        return cleaned_data

core/views.py
import csv
import uuid

from django.core.paginator import Paginator
from django.http import HttpResponseBadRequest, StreamingHttpResponse
from django.shortcuts import get_object_or_404, redirect, render
from django.urls import reverse

from core.models import Dataset, Table
from core.templatetags.utils import obfuscate


max_export_rows = 350000

class Echo:
    def write(self, value):
        return value


def contact(request):
    return render(request, 'contact.html', {})


def queryset_to_csv(data, fields):
    header = None
    for row in data.iterator():
        row_data = {}
        for field in fields:
            if not field.show_on_frontend or field.name == 'search_data':
                continue
            else:
                value = getattr(row, field.name)
                if field.obfuscate:
                    value = obfuscate(value)
                row_data[field.name] = value
        if header is None:
            header = list(row_data.keys())
            yield header
        yield [row_data[field] for field in header]


def index(request):
    return redirect(reverse('core:home'))


def donate(request):
    return redirect('https://apoia.se/brasilio')


def home(request):
    context = {
        'datasets': Dataset.objects.filter(show=True).order_by('?')[:6],
    }
    return render(request, 'home.html', context)


def dataset_list(request):
    context = {
        'datasets': Dataset.objects.filter(show=True).order_by('name'),
    }
    return render(request, 'dataset-list.html', context)


def dataset_detail(request, slug, tablename=''):
    dataset = get_object_or_404(Dataset, slug=slug)
    if not tablename:
        tablename = dataset.get_default_table().name
        return redirect(reverse('core:dataset-table-detail',
                                kwargs={'slug': slug, 'tablename': tablename}))

    try:
        table = dataset.get_table(tablename)
    except Table.DoesNotExist:
        return HttpResponseBadRequest(f'Table does not exist.', status=404)

    version = dataset.version_set.order_by('-order').first()
    fields = table.fields
    fieldnames_to_show = [field.name
                          for field in fields
                          if field.show_on_frontend]
    # TODO: may move this logic to model
    all_data = table.get_model().objects.values(*fieldnames_to_show)
    querystring = request.GET.copy()
    page_number = querystring.pop('page', ['1'])[0].strip() or '1'
    search_query = querystring.pop('search', [''])[0]
    order_by = querystring.pop('order-by', [''])
    order_by = [field.strip().lower()
                for field in order_by[0].split(',')
                if field.strip()]

    if search_query:
        all_data = all_data.search(search_query)
    if querystring:
        all_data = all_data.apply_filters(
            {key: value for key, value in querystring.items() if value}
        )

    all_data = all_data.apply_ordering(order_by)
    if (querystring.get('format', '') == 'csv' and
        0 < all_data.count() <= max_export_rows):
        filename = '{}-{}.csv'.format(slug, uuid.uuid4().hex)
        pseudo_buffer = Echo()
        writer = csv.writer(pseudo_buffer, dialect=csv.excel)
        csv_rows = queryset_to_csv(all_data, fields)
        response = StreamingHttpResponse(
            (writer.writerow(row) for row in csv_rows),
            content_type='text/csv;charset=UTF-8',
        )
        response['Content-Disposition'] = ('attachment; filename="{}"'
                                           .format(filename))
        response.encoding = 'UTF-8'
        return response


    paginator = Paginator(all_data, 20)
    try:
        page = int(page_number)
    except ValueError:
        raise HttpResponseBadRequest
    data = paginator.get_page(page)

    if order_by:
        querystring['order-by'] = ','.join(order_by)
    if search_query:
        querystring['search'] = search_query
    context = {
        'data': data,
        'dataset': dataset,
        'table': table,
        'fields': fields,
        'max_export_rows': max_export_rows,
        'query_dict': querystring,
        'querystring': querystring.urlencode(),
        'search_query': search_query,
        'slug': slug,
        'table': table,
        'total_count': all_data.count(),
        'version': version,
    }
    return render(request, 'dataset-detail.html', context)


def dataset_suggestion(request):
    return render(request, 'dataset-suggestion.html', {})


def manifesto(request):
    return render(request, 'manifesto.html', {})


def collaborate(request):
    return render(request, 'collaborate.html', {})

core/templates/specials/company-groups.html
{% extends 'base.html' %}
{% load l10n %}
{% load static %}
{% load utils %}

{% block title %}Grupos Empresariais - Brasil.IO{% endblock %}

{% block content %}

{% include 'contas-gratuitas.html' %}

<div class="section">

  <form method="get">
    {{ form }}
    <input type="submit" value="Buscar" class="btn">
  </form>
</div>

<div class="section">
  <div class="row">

  {% if errors %}
    <h4>Erros</h4>
    {{ errors }}
  {% elif company %}
  <h4>Grupos Empresariais a que {{ company.name }} pertence:</h4>
  {% for node in nodes %}
    {% if 'EmpresaMae' in node.labels %}
      <div>
        <a href="{% url 'core:special-document-detail' document=node.cnpj_root %}?prefixo_cnpj=True">{{ node.nome }}</a>
      </div>
    {% endif %}
  {% empty %}
    <p>A empresa não pertence a nenhum grupo empresarial ou já é a raiz de um grupo empresarial</p>
  {% endfor %}
  {% endif %}
  </div>
</div>
{% endblock %}

core/templates/specials/document-detail.html
{% extends 'base.html' %}
{% load l10n %}
{% load static %}
{% load utils %}

{% block title %}{{ obj.name }} - {% if obj.document_type == 'CPF' %}Pessoa Física{% elif obj.document_type == 'CNPJ' %}Pessoa Jurídica{% endif %} - Brasil.IO{% endblock %}

{% block head %}
  {{ block.super }}
  <link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/1.10.16/css/dataTables.material.min.css">
{% endblock %}

{% block content %}{% localize off %}{% with client_export_csv=True %}

{% include 'contas-gratuitas.html' %}

<div class="section">
  <h4>{{ obj.name }}</h4>

  {% if branches.count %}
  <p>
    {% if original_document %}
    O documento {{ original_document }} não foi encontrado!
    {% endif %}
    Mostrando informações sobre todas as empresas (filial e matrizes) cujo CNPJ
    começa com {{ doc_prefix }}.
  </p>
  {% endif %}

  <dl>
    <dt> Documento: </dt>
    <dd>{% if encrypted %}{{ obj.document|obfuscate }}{% else %}{{ obj.document }}{% endif %} ({{ obj.document_type|upper }})</b></dd>
    {% if obj.state %}
    <dt> Unidade federativa de registro: </dt>
    <dd>{{ obj.state }}</b></dd>
    {% endif %}
  </dl>

  {% if branches.count %}
  <h4>Filial/Matrizes</h4>
  {% with table_id='branches' data=branches fields=branches_fields caption='branches-'|add:obj.name  %}
    {% include 'data-table.html' %}
  {% endwith %}
  {% endif %}
</div>

<div class="row">

  {% if partners_data.count %}
  <h4>Quadro Societário</h4>
  <p>
    Total de <b>{{ partners_data.count }}</b> sócios.
  </p>
  {% with table_id='partners' data=partners_data fields=partners_fields caption='quadro-societario-'|add:obj.name %}
    {% include 'data-table.html' %}
  {% endwith %}
  {% endif %}

  {% if filiations_data.count %}
  <h4>Filiações</h4>
  <p>
    Foram identificadas <b>{{ filiations_data.count }}</b> filiações a partidos
    políticos vinculadas a esse nome.
    <br>
    Nota: esses registros foram encontrados buscando pelo nome "{{ obj.name }}" e
    podem aparecer homônimos nos resultados.
  </p>
  {% with table_id='filiations' data=filiations_data fields=filiations_fields caption='filiacoes-'|add:obj.name %}
    {% include 'data-table.html' %}
  {% endwith %}
  {% endif %}

  {% if applications_data.count %}
  <h4>Candidaturas</h4>
  <p>
    Foram identificadas <b>{{ applications_data.count }}</b> candidaturas vinculadas
    a esse CPF.
  </p>
  {% with table_id='applications' data=applications_data fields=applications_fields caption='candidaturas-'|add:obj.name  %}
    {% include 'data-table.html' %}
  {% endwith %}
  {% endif %}

  {% if companies_data.count %}
  <h4>Sociedades</h4>
  <p>
    Foram identificadas <b>{{ companies_data.count }}</b> sociedades vinculadas
    {% if obj.document_type == 'CNPJ' %}a esse CNPJ.
    {% elif obj.document_type == 'CPF' %}a esse nome.{% endif %}
    {% if obj.document_type == 'CPF' %}
    <br>
    Nota: esses registros foram encontrados buscando pelo nome "{{ obj.name }}" e
    podem aparecer homônimos nos resultados.
    {% endif %}
  </p>
  {% with table_id='companies' data=companies_data fields=companies_fields caption='sociedades-'|add:obj.name  %}
    {% include 'data-table.html' %}
  {% endwith %}
  {% endif %}

  <h4>Gastos da Cota Parlamentar (Câmara dos Deputados)</h4>
  <p>
    {% if camara_spending_data.count == 0 %}
    Não foram identificados gastos para esse documento.
    {% else %}
    Foram identificadas <b>{{ camara_spending_data.count }}</b> notas.
  </p>
  {% with table_id='camara-spending' data=camara_spending_data fields=camara_spending_fields caption='gastos-deputados-'|add:obj.name  %}
    {% include 'data-table.html' %}
  {% endwith %}
  {% endif %}

  <h4>Gastos Diretos do Governo Federal</h4>
  <p>
    {% if federal_spending_data.count == 0 %}
    Não foram identificados gastos para esse documento.
    {% else %}
    Foram identificadas <b>{{ federal_spending_data.count }}</b> notas.
  </p>
  {% with table_id='federal-spending' data=federal_spending_data fields=federal_spending_fields caption='gastos-diretos-'|add:obj.name  %}
    {% include 'data-table.html' %}
  {% endwith %}
  {% endif %}

</div>
{% endwith %}{% endlocalize %}{% endblock %}

{% block script %}
{{ block.super }}
<script type="text/javascript" language="javascript" src="{% static 'js/jquery.tabletocsv.js' %}"></script>
<script type="text/javascript" language="javascript" src="https://cdn.datatables.net/1.10.16/js/jquery.dataTables.min.js"></script>
<script type="text/javascript">
$(document).ready(function() {
  $('.mdl-data-table').DataTable({
      "scrollY":        "200px",
      "scrollCollapse": true,
      "paging":         false,
      "searching":      false,
      "bInfo":          false,
  });
});
</script>
{% endblock %}

core/templates/specials/index.html
{% extends 'base.html' %}
{% block title %}Especiais - Brasil.IO{% endblock %}
{% block content %}

<h3>Aplicações Especiais</h3>
<div class="divider"></div>

<div class="section">
  <p>
    O Brasil.IO disponibiliza diversos datasets em formatos mais acessíveis
    que nas fontes originais de dados e acreditamos que assim conseguiremos
    não somente melhorar o acesso a dados públicos brasileiros, mas também
    gerar um impacto positivo para a criação de uma nação mais democrática. Porém,
    muitas vezes os datasets sozinhos não são suficientes para descobrir fatos
    - em diversos casos precisamos cruzar datasets para identificar padrões.
    Para resolver esse problema criamos as <b>Aplicações Especiais</b>.
  </p>
  <p>
    <b>Aplicações Especiais</b> são páginas que cruzam dados de diversos
    datasets e facilitam o trabalho investigativo. Se você tiver ideia de dados
    que poderíamos cruzar, <a href="{% url 'core:contact' %}">entre em contato</a>.
  </p>

  <h4>Aplicações Disponíveis</h4>

  <ul>
    <li>
      <b>Dossiê de Pessoa (Física ou Jurídica)</b> - a partir de uma <a
        href="{% url 'core:dataset-detail' slug='documentos-brasil' %}">busca
        por nome ou documento</a> o visitante poderá acessar um dossiê do
      documento (CPF ou CNPJ), onde serão mostradas ocorrências em vários
      datasets disponíveis no portal. Exemplo:
      <a href="{% url 'core:special-document-detail' document='75095679000149' %}">
        Universidade Federal do Paraná
      </a>.
    </li>
    <li>
      <a href="{% url 'core:special-trace-path' %}">Caminhos nas relações
        pessoais (física e/ou jurídica)</a> - a partir de duas pessoas (físicas
      e/ou jurídicas) o visitante conseguirá verificar a existência de uma
      relação de sociedade, independente do nível (exemplo: A é sócio da
      empresa X, que é sócia da empresa Y e tem como sócio também Z - dessa
      forma, A é indiretamente sócio de Z). Exemplo real:
      <a href="{% url 'core:special-trace-path' %}?origin_type=pessoa-juridica&origin_identifier=15102288000182&destination_type=pessoa-juridica&destination_identifier=61065751000180">qual a
        ligação entre a Rossi Residencial SA e a Construtora Norberto Odebrecht
      SA?</a>
    </li>
    <li>
      <a href="{% url 'core:special-company-groups' %}">Grupos Empresariais de uma empresa</a> -
      Com o CNPJ de uma empresa, podemos listar a qual ou quais grupos empresariais
      a empresa pertence. Um grupo empresarial é determinado através das relações
      de sociedades entre empresas (exemplo: a empresa A é sócia de B que também tem
      como sócia a empresa C - dessa forma, B pertence aos grupos empresariais de A e C).
      Exemplo real: <a href="{% url 'core:special-company-groups' %}?identifier=24657281000123">qual
      os grupos empresariais da empresa Passos Construções SPE LTDA?</a>
    </li>
  </ul>


{% include 'contas-gratuitas.html' %}

</div>
{% endblock %}

core/templates/specials/registry.html
{% extends 'base.html' %}
{% block title %}Registro Nacional - Busca - Brasil.IO{% endblock %}
{% block content %}

{% include 'contas-gratuitas.html' %}

<div class="section">
  <h4>Registro Nacional</h4>
  <p>
    <form method="get">
      <div class="input-field col s6">
        <label for="q">Busque por nome, CPF, razão social ou CNPJ</label>
        <input autofocus type="text" id="q" name="q" value="{{ query|default:'' }}">
        <input class="btn" type="submit" value="Buscar">
      </div>
    </form>
  </p>
</div>

<div class="row">

  {% if query %}

    {% if not data.count %}
    Nenhum resultado encontrado. :(
    {% else %}
    Total de <b>{{ data.count }}</b> registros encontrados (entre pessoas
    físicas e jurídicas){% if data.count > 500 %}, mostrando os <b>500</b>
    primeiros).{% else %}.{% endif %}

    {% include 'data-table.html' %}

    {% endif %}

  {% endif %}

</div>
{% endblock %}

core/templates/specials/trace-path.html
{% extends 'base.html' %}
{% load l10n %}
{% load static %}
{% load utils %}

{% block title %}Traçador de Caminhos - Brasil.IO{% endblock %}

{% block content %}

{% include 'contas-gratuitas.html' %}

<div class="section">

  <form method="get">
    {{ form }}
    <input type="submit" value="Traçar" class="btn">
  </form>
</div>

<div class="section">
  <div class="row">

  {% if errors %}
    <h4>Erros</h4>
    {{ errors }}
  {% elif nodes %}
  <h4>Caminho entre {{ origin_name }} e {{ destination_name }}</h4>
  {% for node in nodes %}
    <div>
      {% if node.tipo == 'PessoaJuridica' or node.tipo == 'EmpresaMae' %}
      <a href="{% url 'core:special-document-detail' document=node.cnpj %}">{{ node.nome }}</a>
      {% else %}
      <a href="{% url 'core:dataset-table-detail' 'socios-brasil' 'socios' %}?nome_socio={{ node.nome }}">{{ node.nome }}</a>
      {% endif %}
    </div>
    {% endfor %}
  {% elif form.is_valid %}
  Nenhum caminho encontrado.
  {% endif %}
  </div>
</div>
{% endblock %}

{% block script %}
{{ block.super }}
<script type="text/javascript">
$(document).ready(function() {
  $('select').formSelect();
});
</script>
{% endblock %}